From f8748aae4eceb8279ee37eae008437572edf8204 Mon Sep 17 00:00:00 2001
From: Peter Geoghegan <pg@bowt.ie>
Date: Thu, 3 Dec 2020 16:50:10 -0800
Subject: [PATCH v11 2/2] Add bottom-up index deletion.

Teach heapam and nbtree to eagerly delete duplicate tuples that
represent old versions.  This leaf page level process is triggered in
response to a flood of versions on the page.  Heuristics detect the
problem at the leaf page level (including the recently added "index is
logically unchanged by an UPDATE" executor hint).

The immediate goal of bottom-up index deletion in nbtree is to avoid
"unnecessary" page splits caused entirely by duplicates needed only for
MVCC/versioning purposes.  It naturally has an even more useful effect,
though: it acts as a backstop against accumulating an excessive number
of index tuple versions for any given _logical row_.  Note that the
relationship between this localized condition and the proportion of
garbage tuples in the entire index is very loose, and can be very
volatile.  Bottom-up index deletion complements what we might now call
"top-down index deletion": index vacuuming performed by VACUUM.  It
responds to the immediate local needs of queries, while leaving it up to
autovacuum to perform infrequent clean sweeps of the index.

Also extend deletion of LP_DEAD-marked index tuples by teaching it to
delete extra index tuples (that are not LP_DEAD-marked) in passing.
This increases the number of index tuples deleted significantly in many
cases (and typically doesn't necessitate that the deletion process
visits extra table blocks, unlike bottom-up deletion).  Testing has
shown that the enhanced LP_DEAD deletion process almost never fails to
delete at least a few extra not-LP_DEAD-marked index tuples when the
regression tests are run.  In practice the enhanced deletion process can
pick up a surprisingly large number of "extra" index tuples; this can
even significantly exceed the number of LP_DEAD-marked tuples.

The previous table interface (the table_compute_xid_horizon_for_tuples()
function) has been replaced with a new interface that supports all of
our new requirements.  At least some of the capabilities added to nbtree
by this commit could be extended to other index AMs without too much
trouble.  It would be fairly straightforward to add support for
including "extra" TIDs when deleting LP_DEAD-marked index tuples to both
the hash AM and GiST AM.  That's left as work for a future commit.

This commit extends nbtree's _bt_delitems_delete() function to support
granular TID deletion in posting list tuples.  Bottom-up index deletion
and the enhanced LP_DEAD deletion process both support deleting
individual TIDs from posting list tuples.  This enhancement avoids
possible performance issues caused by posting list tuples having only
one single LP_DEAD bit.  In practice there is a fairly good chance that
we'll pick up a subset of the posting list TIDs in passing, so it may
well not matter that it still isn't possible to individually mark each
posting list TID LP_DEAD.

Bump XLOG_PAGE_MAGIC because xl_btree_delete changed.

No bump in BTREE_VERSION, since there are no changes to the on-disk
representation of nbtree indexes.  Indexes built on PostgreSQL 12 or
PostgreSQL 13 will automatically benefit from the optimization (i.e. no
reindexing required) following a pg_upgrade.

Author: Peter Geoghegan <pg@bowt.ie>
Reviewed-By: Heikki Linnakangas <hlinnaka@iki.fi>
Reviewed-By: Victor Yegorov <vyegorov@gmail.com>
Discussion: https://postgr.es/m/CAH2-Wzm+maE3apHB8NOtmM=p-DO65j2V5GzAWCOEEuy3JZgb2g@mail.gmail.com
---
 src/include/access/heapam.h              |   5 +-
 src/include/access/nbtree.h              |  23 +-
 src/include/access/nbtxlog.h             | 101 +++--
 src/include/access/tableam.h             | 143 +++++-
 src/backend/access/common/reloptions.c   |  10 +
 src/backend/access/heap/heapam.c         | 546 +++++++++++++++++++++--
 src/backend/access/heap/heapam_handler.c |   2 +-
 src/backend/access/index/genam.c         |  41 +-
 src/backend/access/nbtree/README         | 133 +++++-
 src/backend/access/nbtree/nbtdedup.c     | 320 ++++++++++++-
 src/backend/access/nbtree/nbtinsert.c    | 357 +++++++++++++--
 src/backend/access/nbtree/nbtpage.c      | 494 ++++++++++++++------
 src/backend/access/nbtree/nbtree.c       |   2 +-
 src/backend/access/nbtree/nbtsort.c      |   1 -
 src/backend/access/nbtree/nbtutils.c     |   4 +-
 src/backend/access/nbtree/nbtxlog.c      |  94 ++--
 src/backend/access/table/tableam.c       |   6 +-
 src/backend/access/table/tableamapi.c    |   2 +-
 src/bin/psql/tab-complete.c              |   4 +-
 doc/src/sgml/btree.sgml                  | 109 ++++-
 doc/src/sgml/ref/create_index.sgml       |  16 +
 21 files changed, 2055 insertions(+), 358 deletions(-)

diff --git a/src/include/access/heapam.h b/src/include/access/heapam.h
index 54b2eb7378..a0d55c9165 100644
--- a/src/include/access/heapam.h
+++ b/src/include/access/heapam.h
@@ -166,9 +166,8 @@ extern void simple_heap_delete(Relation relation, ItemPointer tid);
 extern void simple_heap_update(Relation relation, ItemPointer otid,
 							   HeapTuple tup);
 
-extern TransactionId heap_compute_xid_horizon_for_tuples(Relation rel,
-														 ItemPointerData *items,
-														 int nitems);
+extern TransactionId heap_compute_delete_for_tuples(Relation rel,
+													TM_IndexDeleteOp *delstate);
 
 /* in heap/pruneheap.c */
 struct GlobalVisState;
diff --git a/src/include/access/nbtree.h b/src/include/access/nbtree.h
index 3b60e696eb..b80fc47806 100644
--- a/src/include/access/nbtree.h
+++ b/src/include/access/nbtree.h
@@ -17,6 +17,7 @@
 #include "access/amapi.h"
 #include "access/itup.h"
 #include "access/sdir.h"
+#include "access/tableam.h"
 #include "access/xlogreader.h"
 #include "catalog/pg_am_d.h"
 #include "catalog/pg_index.h"
@@ -766,8 +767,9 @@ typedef struct BTDedupStateData
 typedef BTDedupStateData *BTDedupState;
 
 /*
- * BTVacuumPostingData is state that represents how to VACUUM a posting list
- * tuple when some (though not all) of its TIDs are to be deleted.
+ * BTVacuumPostingData is state that represents how to VACUUM (or delete) a
+ * posting list tuple when some (though not all) of its TIDs are to be
+ * deleted.
  *
  * Convention is that itup field is the original posting list tuple on input,
  * and palloc()'d final tuple used to overwrite existing tuple on output.
@@ -963,6 +965,7 @@ typedef struct BTOptions
 	/* fraction of newly inserted tuples prior to trigger index cleanup */
 	float8		vacuum_cleanup_index_scale_factor;
 	bool		deduplicate_items;	/* Try to deduplicate items? */
+	bool		delete_items;	/* Bottom-up delete items? */
 } BTOptions;
 
 #define BTGetFillFactor(relation) \
@@ -978,6 +981,11 @@ typedef struct BTOptions
 				 relation->rd_rel->relam == BTREE_AM_OID), \
 	((relation)->rd_options ? \
 	 ((BTOptions *) (relation)->rd_options)->deduplicate_items : true))
+#define BTGetDeleteItems(relation) \
+	(AssertMacro(relation->rd_rel->relkind == RELKIND_INDEX && \
+				 relation->rd_rel->relam == BTREE_AM_OID), \
+	((relation)->rd_options ? \
+	 ((BTOptions *) (relation)->rd_options)->delete_items : true))
 
 /*
  * Constant definition for progress reporting.  Phase numbers must match
@@ -1031,6 +1039,8 @@ extern void _bt_parallel_advance_array_keys(IndexScanDesc scan);
 extern void _bt_dedup_pass(Relation rel, Buffer buf, Relation heapRel,
 						   IndexTuple newitem, Size newitemsz,
 						   bool checkingunique);
+extern bool _bt_bottomup_pass(Relation rel, Buffer buf, Relation heapRel,
+							  Size newitemsz);
 extern void _bt_dedup_start_pending(BTDedupState state, IndexTuple base,
 									OffsetNumber baseoff);
 extern bool _bt_dedup_save_htid(BTDedupState state, IndexTuple itup);
@@ -1045,7 +1055,8 @@ extern IndexTuple _bt_swap_posting(IndexTuple newitem, IndexTuple oposting,
  * prototypes for functions in nbtinsert.c
  */
 extern bool _bt_doinsert(Relation rel, IndexTuple itup,
-						 IndexUniqueCheck checkUnique, Relation heapRel);
+						 IndexUniqueCheck checkUnique, bool indexUnchanged,
+						 Relation heapRel);
 extern void _bt_finish_split(Relation rel, Buffer lbuf, BTStack stack);
 extern Buffer _bt_getstackbuf(Relation rel, BTStack stack, BlockNumber child);
 
@@ -1083,9 +1094,9 @@ extern bool _bt_page_recyclable(Page page);
 extern void _bt_delitems_vacuum(Relation rel, Buffer buf,
 								OffsetNumber *deletable, int ndeletable,
 								BTVacuumPosting *updatable, int nupdatable);
-extern void _bt_delitems_delete(Relation rel, Buffer buf,
-								OffsetNumber *deletable, int ndeletable,
-								Relation heapRel);
+extern void _bt_delitems_delete_check(Relation rel, Buffer buf,
+									  Relation heapRel,
+									  TM_IndexDeleteOp *delstate);
 extern uint32 _bt_pagedel(Relation rel, Buffer leafbuf,
 						  TransactionId *oldestBtpoXact);
 
diff --git a/src/include/access/nbtxlog.h b/src/include/access/nbtxlog.h
index 5c014bdc66..db1eb11042 100644
--- a/src/include/access/nbtxlog.h
+++ b/src/include/access/nbtxlog.h
@@ -176,24 +176,6 @@ typedef struct xl_btree_dedup
 
 #define SizeOfBtreeDedup 	(offsetof(xl_btree_dedup, nintervals) + sizeof(uint16))
 
-/*
- * This is what we need to know about delete of individual leaf index tuples.
- * The WAL record can represent deletion of any number of index tuples on a
- * single index page when *not* executed by VACUUM.  Deletion of a subset of
- * the TIDs within a posting list tuple is not supported.
- *
- * Backup Blk 0: index page
- */
-typedef struct xl_btree_delete
-{
-	TransactionId latestRemovedXid;
-	uint32		ndeleted;
-
-	/* DELETED TARGET OFFSET NUMBERS FOLLOW */
-} xl_btree_delete;
-
-#define SizeOfBtreeDelete	(offsetof(xl_btree_delete, ndeleted) + sizeof(uint32))
-
 /*
  * This is what we need to know about page reuse within btree.  This record
  * only exists to generate a conflict point for Hot Standby.
@@ -211,9 +193,61 @@ typedef struct xl_btree_reuse_page
 #define SizeOfBtreeReusePage	(sizeof(xl_btree_reuse_page))
 
 /*
- * This is what we need to know about which TIDs to remove from an individual
- * posting list tuple during vacuuming.  An array of these may appear at the
- * end of xl_btree_vacuum records.
+ * xl_btree_vacuum and xl_btree_delete records describe deletion of index
+ * tuples on a leaf page.  The former variant is used by VACUUM, while the
+ * latter variant is used by the ad-hoc deletions that sometimes take place
+ * when btinsert() is called.
+ *
+ * The records are very similar.  The only difference is that xl_btree_delete
+ * has to include a latestRemovedXid field to generate recovery conflicts.
+ * (VACUUM operations can just rely on earlier conflicts generated during
+ * pruning of the table whose TIDs the to-be-deleted index tuples point to.
+ * There are also small differences between each REDO routine that we don't go
+ * into here.)
+ *
+ * xl_btree_vacuum and xl_btree_delete both represent deletion of any number
+ * of index tuples on a single leaf page using page offset numbers.  Both also
+ * support "updates" of index tuples, which is how deletes of a subset of TIDs
+ * contained in an existing posting list tuple are implemented.
+ *
+ * Updated posting list tuples are represented using xl_btree_update metadata.
+ * The REDO routines each use the xl_btree_update entries (plus each
+ * corresponding original index tuple from the target leaf page) to generate
+ * the final updated tuple.
+ *
+ * Updates are only used when there will be some remaining TIDs left by the
+ * REDO routine.  Otherwise the posting list tuple just gets deleted outright.
+ */
+typedef struct xl_btree_vacuum
+{
+	uint16		ndeleted;
+	uint16		nupdated;
+
+	/* DELETED TARGET OFFSET NUMBERS FOLLOW */
+	/* UPDATED TARGET OFFSET NUMBERS FOLLOW */
+	/* UPDATED TUPLES METADATA (xl_btree_update) ARRAY FOLLOWS */
+} xl_btree_vacuum;
+
+#define SizeOfBtreeVacuum	(offsetof(xl_btree_vacuum, nupdated) + sizeof(uint16))
+
+typedef struct xl_btree_delete
+{
+	TransactionId latestRemovedXid;
+	uint16		ndeleted;
+	uint16		nupdated;
+
+	/* DELETED TARGET OFFSET NUMBERS FOLLOW */
+	/* UPDATED TARGET OFFSET NUMBERS FOLLOW */
+	/* UPDATED TUPLES METADATA (xl_btree_update) ARRAY FOLLOWS */
+} xl_btree_delete;
+
+#define SizeOfBtreeDelete	(offsetof(xl_btree_delete, nupdated) + sizeof(uint16))
+
+/*
+ * The offsets that appear in xl_btree_update metadata are offsets into the
+ * original posting list from tuple, not page offset numbers.  These are
+ * 0-based.  The page offset number for the original posting list tuple comes
+ * from main xl_btree_delete/xl_btree_vacuum record.
  */
 typedef struct xl_btree_update
 {
@@ -224,31 +258,6 @@ typedef struct xl_btree_update
 
 #define SizeOfBtreeUpdate	(offsetof(xl_btree_update, ndeletedtids) + sizeof(uint16))
 
-/*
- * This is what we need to know about a VACUUM of a leaf page.  The WAL record
- * can represent deletion of any number of index tuples on a single index page
- * when executed by VACUUM.  It can also support "updates" of index tuples,
- * which is how deletes of a subset of TIDs contained in an existing posting
- * list tuple are implemented. (Updates are only used when there will be some
- * remaining TIDs once VACUUM finishes; otherwise the posting list tuple can
- * just be deleted).
- *
- * Updated posting list tuples are represented using xl_btree_update metadata.
- * The REDO routine uses each xl_btree_update (plus its corresponding original
- * index tuple from the target leaf page) to generate the final updated tuple.
- */
-typedef struct xl_btree_vacuum
-{
-	uint16		ndeleted;
-	uint16		nupdated;
-
-	/* DELETED TARGET OFFSET NUMBERS FOLLOW */
-	/* UPDATED TARGET OFFSET NUMBERS FOLLOW */
-	/* UPDATED TUPLES METADATA ARRAY FOLLOWS */
-} xl_btree_vacuum;
-
-#define SizeOfBtreeVacuum	(offsetof(xl_btree_vacuum, nupdated) + sizeof(uint16))
-
 /*
  * This is what we need to know about marking an empty subtree for deletion.
  * The target identifies the tuple removed from the parent page (note that we
diff --git a/src/include/access/tableam.h b/src/include/access/tableam.h
index 387eb34a61..2d2228f4aa 100644
--- a/src/include/access/tableam.h
+++ b/src/include/access/tableam.h
@@ -128,6 +128,123 @@ typedef struct TM_FailureData
 	bool		traversed;
 } TM_FailureData;
 
+/*
+ * State representing call to table_compute_delete_for_tuples(), which checks
+ * TID status with tableam for index deletion purposes.
+ *
+ * Index am caller provides a TM_IndexDeleteOp, which points to two palloc()'d
+ * arrays.  Each array has one entry per TID that the tableam is asked to
+ * consider (typically these are all of the TIDs from a single index page, so
+ * there could be hundreds or even thousand of entries in arrays).  ndeltids
+ * tracks the current number of entries, and is set by index AM initially.
+ *
+ * The two arrays are conceptually one single variable-sized array.  Two
+ * arrays/structs are used for performance reasons.  (We really need to keep
+ * the TM_IndexDelete struct small so that the tableam can do an initial sort
+ * by TID as quickly as possible.)
+ *
+ * Regular deletion callers and bottom-up deletion callers:
+ *
+ * Most index AM callers specify bottomup = false, and include only known-dead
+ * deltids.  These known-dead entries are marked deleteitup = true directly
+ * (typically these are TIDs from LP_DEAD-marked index tuples).  Callers that
+ * only call table_compute_delete_for_tuples() to get a latestRemovedXid
+ * transaction ID can take this simple approach, and don't need to do anything
+ * with the final array (the call can even be skipped entirely with an
+ * unlogged index).  This usage is all that the previous interface (the old
+ * compute_xid_horizon_for_tuples() routine) ever supported in prior versions
+ * (those before PostgreSQL 14).
+ *
+ * Callers that specify bottomup = true are "bottom-up index deletion"
+ * callers.  The considerations here are somewhat more subtle.  Most of the
+ * complexity of the current interface exists to support bottom-up deletion.
+ *
+ * The final contents of the array are always interesting to bottom-up
+ * callers, because they need to consult it to determine which index tuples
+ * are actually safe to delete.  Entries for a bottom-up caller must always be
+ * initially marked deleteitup = false, leaving it up to the tableam to
+ * determine which entries are safely deletable.  Which index tuples to get
+ * deltids entries from in the first place is up to the index AM, but it's
+ * expected that index AMs take TIDs from version churn index tuple
+ * duplicates.  The index AM should cast a wide net (for example by including
+ * all TIDs on a given index page), and leave it up to the tableam to worry
+ * about the cost of checking transaction status information.  See also: notes
+ * below about "promising" tuples.
+ *
+ * Some regular deletion callers (!bottomup callers) may also have to look at
+ * the final deltids array to decide exactly what to delete.  This happens
+ * with !bottomup callers that speculatively ask table to check extra TIDs in
+ * passing, somewhat like the bottom-up deletion case (though tableam does not
+ * access whole table blocks speculatively here).  The table blocks are blocks
+ * that tableam is expected to visit anyway, so there is no reason to not be
+ * open to the possibility of finding extra deletable entries.  This works by
+ * having !bottomup caller include deltids that are initially marked
+ * deleteitup = false (extra etnries that go along with the usual known
+ * dead-to-all etnries).  It may be possible for the caller to ultimate delete
+ * these extra TIDs, but if it isn't then it's no great loss.
+ *
+ * The convention is that index AM caller takes TIDs whose block number
+ * happens to match any single including deltid that is already known
+ * dead-to-all.  This makes it cheap to check in passing, at least with
+ * heap-style tableams.  (A tableam that wants to opt out can simply ignore
+ * entries marked deleteitup = false.  In general the tableam is entitled to
+ * do nothing at all with any deleteitup = false deltid, based on
+ * tableam-local performance considerations.)
+ *
+ * The index AM can keep track of which index tuple relates to which deltid by
+ * setting idxoffnum (and/or relying on each entry being uniquely identifiable
+ * using tid).  That's how callers that care about the final deltids array
+ * (both bottom-up callers and regular deletion callers that include "extra"
+ * deletions) can relocate the required deltid for each index tuple.  Such a
+ * system must be necessary because a table_compute_delete_for_tuples()
+ * implementation can change the sort order of deltids, and can even reduce
+ * the number of deltids by modifying ndeltids.  Bottom-up callers may even
+ * find that ndeltids is set to 0 for them (which means that they cannot
+ * proceed with any deletions).
+ *
+ * Bottom-up deletion, index tuple space savings, and promising tuples:
+ *
+ * Index AM requests an amount of target free space bottomupfreespace.  They
+ * must also specify the amount of space freed by each deltid by setting
+ * tupsize (this includes line pointer overhead).  This information enables
+ * intelligent managements of costs within the tableam.  The tableam drives
+ * the progress of bottom-up index deletion, and ramps up as needed.  All
+ * !bottomup callers set these to zero, since there isn't any question about
+ * which table blocks will be visited.
+ *
+ * The index AM also provides strong hints about where to look to the tableam
+ * by marking some entries as "promising".  Index AM does this with duplicate
+ * index tuples that are strongly suspected to be old versions left behind by
+ * UPDATEs that did not logically changed any indexed values.  Index AM may
+ * find it helpful to only mark TIDs/entries as promising when they're thought
+ * to have been affected by such an UPDATE in the recent past.  Again, this
+ * isn't useful to !bottomup callers.
+ */
+typedef struct TM_IndexDelete
+{
+	ItemPointerData tid;		/* table TID from index tuple */
+	int16		id;				/* Offset into TM_IndexStatus array */
+} TM_IndexDelete;
+
+typedef struct TM_IndexStatus
+{
+	OffsetNumber idxoffnum;		/* Index am page offset number */
+	int16		tupsize;		/* Space freed in index if tuple deleted */
+	bool		ispromising;	/* Duplicate in index? */
+	bool		deleteitup;		/* Known dead-to-all? */
+} TM_IndexStatus;
+
+typedef struct TM_IndexDeleteOp
+{
+	bool		bottomup;			/* Bottom-up deletion/opportunistic? */
+	int			bottomupfreespace;	/* Space target for tableam */
+
+	/* Mutable state follows */
+	int			ndeltids;		/* Number of deltids/status for op */
+	TM_IndexDelete *deltids;
+	TM_IndexStatus *status;
+} TM_IndexDeleteOp;
+
 /* "options" flag bits for table_tuple_insert */
 /* TABLE_INSERT_SKIP_WAL was 0x0001; RelationNeedsWAL() now governs */
 #define TABLE_INSERT_SKIP_FSM		0x0002
@@ -342,10 +459,9 @@ typedef struct TableAmRoutine
 											 TupleTableSlot *slot,
 											 Snapshot snapshot);
 
-	/* see table_compute_xid_horizon_for_tuples() */
-	TransactionId (*compute_xid_horizon_for_tuples) (Relation rel,
-													 ItemPointerData *items,
-													 int nitems);
+	/* see table_compute_delete_for_tuples() */
+	TransactionId (*compute_delete_for_tuples) (Relation rel,
+												TM_IndexDeleteOp *delstate);
 
 
 	/* ------------------------------------------------------------------------
@@ -1122,16 +1238,21 @@ table_tuple_satisfies_snapshot(Relation rel, TupleTableSlot *slot,
 }
 
 /*
- * Compute the newest xid among the tuples pointed to by items. This is used
- * to compute what snapshots to conflict with when replaying WAL records for
- * page-level index vacuums.
+ * Compute which index tuples are safe to delete, and the newest xid among the
+ * tuples that caller finds it is able to delete.
+ *
+ * Sets deletable tuples in entries from caller's TM_IndexDeleteOp state that
+ * are found to point to dead-to-all tuples in the table.  See the
+ * TM_IndexDeleteOp struct for full details.
+ *
+ * Returns a latestRemovedXid transaction ID that index AM must use to
+ * generate a recovery conflict when required.  This is the newest xid among
+ * the tuples pointed to by deltids TIDs that caller can delete.
  */
 static inline TransactionId
-table_compute_xid_horizon_for_tuples(Relation rel,
-									 ItemPointerData *items,
-									 int nitems)
+table_compute_delete_for_tuples(Relation rel, TM_IndexDeleteOp *delstate)
 {
-	return rel->rd_tableam->compute_xid_horizon_for_tuples(rel, items, nitems);
+	return rel->rd_tableam->compute_delete_for_tuples(rel, delstate);
 }
 
 
diff --git a/src/backend/access/common/reloptions.c b/src/backend/access/common/reloptions.c
index 8ccc228a8c..95e29345de 100644
--- a/src/backend/access/common/reloptions.c
+++ b/src/backend/access/common/reloptions.c
@@ -168,6 +168,16 @@ static relopt_bool boolRelOpts[] =
 		},
 		true
 	},
+	{
+		{
+			"delete_items",
+			"Enables \"bottom-up index deletion\" feature for this btree index",
+			RELOPT_KIND_BTREE,
+			ShareUpdateExclusiveLock	/* since it applies only to later
+										 * inserts */
+		},
+		true
+	},
 	/* list terminator */
 	{{NULL}}
 };
